#pragma once

typedef struct LLStruct LLType, *LLPtr, **LLHandle;
struct LLStruct { union { LLHandle hnext; LLPtr pnext; } u; };

/* macros so we don't have to worry about type casting to/from LLHandle */
#define LLHValid(item)			LLHValid((LLHandle)(item))
#define LLHNext(item)			((void*)LLHNext((LLHandle)(item)))
#define LLHInsert(head,item)	((void*)LLHInsert((LLHandle)(head),(LLHandle)(item)))
#define LLHAppend(head,item)	((void*)LLHAppend((LLHandle)(head),(LLHandle)(item)))
#define LLHDelete(head,item)	((void*)LLHDelete((LLHandle)(head),(LLHandle)(item)))
#define LLHDeleteFast(head,item,prev)	((void*)LLHDeleteFast((LLHandle)(head),(LLHandle)(item),(LLHandle)(prev)))

/* macros so we don't have to worry about type casting to/from LLPtr */
#define LLPValid(item)			LLPValid((LLPtr)(item))
#define LLPNext(item)			((void*)LLPNext((LLPtr)(item)))
#define LLPInsert(head,item)	((void*)LLPInsert((LLPtr)(head),(LLPtr)(item)))
#define LLPAppend(head,item)	((void*)LLPAppend((LLPtr)(head),(LLPtr)(item)))
#define LLPDelete(head,item)	((void*)LLPDelete((LLPtr)(head),(LLPtr)(item)))
#define LLPDeleteFast(head,item,prev)	((void*)LLPDeleteFast((LLPtr)(head),(LLPtr)(item),(LLPtr)(prev)))

/* prototypes for handle based functions */
Boolean (LLHValid)(LLHandle item);
LLHandle (LLHNext)(LLHandle item);
LLHandle (LLHInsert)(LLHandle head, LLHandle item);
LLHandle (LLHAppend)(LLHandle head, LLHandle item);
LLHandle (LLHDelete)(LLHandle head, LLHandle item);
LLHandle (LLHDeleteFast)(LLHandle head, LLHandle item, LLHandle prev);

/* prototypes for pointer based functions */
Boolean (LLPValid)(LLPtr item);
LLPtr (LLPNext)(LLPtr item);
LLPtr (LLPInsert)(LLPtr head, LLPtr item);
LLPtr (LLPAppend)(LLPtr head, LLPtr item);
LLPtr (LLPDelete)(LLPtr head, LLPtr item);
LLPtr (LLPDeleteFast)(LLPtr head, LLPtr item, LLPtr prev);
