#pragma once

#include <stddef.h>
#include "LLPtrLib.h"

typedef struct {
	LLType next;
	/* ... more data ... */
} LListStruct, *LListType;

Boolean LListValid(LListType head);
LListType LListBegin(void);
void LListEnd(LListType head);
void *LListData(LListType item);
size_t LListDataSize(LListType item);
LListType LListNext(LListType item);
LListType LListFind(LListType head, const void *data,
	int (*compare)(const void *data1, const void *data2));
LListType LListNew(const void *data, size_t size);
LListType LListInsert(LListType head, LListType item);
LListType LListDelete(LListType head, LListType item);
LListType LListMoveToFront(LListType head, LListType item);
